#ifndef SOLUTION_H_
#define SOLUTION_H_

void compute_f_g(double **F, double **G,
        double **U, double **V, double **P, double re, 
        int nx, int ny, double dx, double dy,
        double gx, double gy, double dt, double gamma);

void compute_rhs(double **RHS, double **F, double **G,
        double dt, double dx, double dy, int nx, int ny);

void sor_cycle(double **P, double **RHS, double omega,
        int nx, int ny, double dx, double dy);

double max_residual_norm(double **RES, double **P, double **RHS,
        int nx, int ny, double dx, double dy);

void correct_velocities(double **U, double **V, double **F, double **G, 
        double **P, int nx, int ny, double dt, double dx, double dy);
#endif
