#ifndef FILE_IO_H_
#define FILE_IO_H_

int read_file(char *path,
        double *t, double *t_end, double *t_file, double *tau, int *itermax,
        double *epsilon, double *omega, double *gamma,
        double *gx, double *gy, double *re,
        int *w_left, int *w_right, int *w_top, int *w_bottom,
        double *dx, double *dy,
        int *nx, int *ny,
        double ***P, double ***U, double ***V);

int write_file(char *path,
        double *t, double *t_end, double *t_file, double *tau, int *itermax,
        double *epsilon, double *omega, double *gamma,
        double *gx, double *gy, double *re,
        int *w_left, int *w_right, int *w_top, int *w_bottom,
        double *dx, double *dy,
        int *nx, int *ny,
        double ***P, double ***U, double ***V);
#endif
