#ifndef UTILITY_H_
#define UTILITY_H_

int allocate_matrix(double ***M, int nx, int ny);
void free_matrix(double ***M, int nx);

int allocate_memory(double ***P, double ***U, double ***V, int nx, int ny);
void free_memory(double **P, double **U, double **V, int nx);

double select_time_step(double tau, double re, double dx, double dy,
        int nx, int ny, double **U, double **V);

void print_matrix(char* description, double **M, int nx, int ny);

#endif
